package aicare.net.cn.sdk.ailinksdkdemoandroid;


import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.text.TextUtils;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.TextView;
import android.widget.Toast;

import androidx.activity.result.ActivityResultLauncher;
import androidx.annotation.Nullable;

import com.pingwang.bluetoothlib.bean.BleValueBean;
import com.pingwang.bluetoothlib.config.CmdConfig;
import com.pingwang.bluetoothlib.device.BleDevice;
import com.pingwang.bluetoothlib.listener.OnCallbackBle;
import com.pingwang.bluetoothlib.utils.BleLog;
import com.pingwang.bluetoothlib.utils.BleStrUtils;

import java.io.File;
import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

import aicare.net.cn.sdk.ailinksdkdemoandroid.base.BleBaseActivity;
import aicare.net.cn.sdk.ailinksdkdemoandroid.config.BleDeviceConfig;
import aicare.net.cn.sdk.ailinksdkdemoandroid.dialog.DialogStringImageBean;
import aicare.net.cn.sdk.ailinksdkdemoandroid.dialog.ShowListDialogFragment;
import aicare.net.cn.sdk.ailinksdkdemoandroid.dialog.WifiDialog;
import aicare.net.cn.sdk.ailinksdkdemoandroid.utils.FileUtils;
import aicare.net.cn.sdk.ailinksdkdemoandroid.utils.ResultContact;
import aicare.net.cn.sdk.ailinksdkdemoandroid.utils.SP;
import cn.net.aicare.modulelibrary.module.BodyFatScale.AppHistoryRecordBean;
import cn.net.aicare.modulelibrary.module.BodyFatScale.BodyFatBleUtilsData;
import cn.net.aicare.modulelibrary.module.BodyFatScale.BodyFatDataUtil;
import cn.net.aicare.modulelibrary.module.BodyFatScale.BodyFatRecord;
import cn.net.aicare.modulelibrary.module.BodyFatScale.McuHistoryRecordBean;
import cn.net.aicare.modulelibrary.module.BodyFatScale.User;

/**
 * wifi+ble体脂秤
 */
public class WeightScaleWifiBleActivity extends BleBaseActivity implements View.OnClickListener, OnCallbackBle, BodyFatBleUtilsData.BleBodyFatCallback, BodyFatBleUtilsData.BleBodyFatWiFiCallback {
    private String TAG = WeightScaleWifiBleActivity.class.getName();
    private String mAddress;
    private List<String> mList;
    private ArrayAdapter listAdapter;
    //    private Button wifiStatus_btn;
    private BodyFatBleUtilsData bodyFatBleUtilsData;
    private MHandler mMHandler;
    private EditText mEditText;
    private RadioButton kg, jing, stlb, lb;

    private EditText et_ip, et_url, et_port;
    private TextView tv_path;

    private byte[] testIp = new byte[]{0x74, 0x65, 0x73, 0x74, 0x2e, 0x61, 0x69, 0x6c, 0x69, 0x6e, 0x6b, 0x2e, 0x72, 0x65, 0x76, 0x69, 0x63, 0x65, 0x2e, 0x61, 0x69, 0x63, 0x61, 0x72, 0x65, 0x2e, 0x6e, 0x65, 0x74, 0x2e, 0x63, 0x6e};

    private byte[] productIp = new byte[]{0x61, 0x69, 0x6c, 0x69, 0x6e, 0x6b, 0x2e, 0x69, 0x6f, 0x74, 0x2e, 0x61, 0x69, 0x63, 0x61, 0x72, 0x65, 0x2e, 0x6e, 0x65, 0x74, 0x2e, 0x63, 0x6e};

    private byte[] IpUrl = new byte[]{0x2f, 0x64, 0x65, 0x76, 0x69, 0x76, 0x63, 0x64, 0x2f, 0x73, 0x65, 0x72, 0x76, 0x64, 0x72, 0x52, 0x65, 0x64, 0x69, 0x72, 0x65, 0x63, 0x74, 0x2f};
    private boolean isTest = false;
    private ArrayList<DialogStringImageBean> mDialogList;

    private ActivityResultLauncher<Boolean> launcher;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);//禁止横屏
        setContentView(R.layout.activity_weight_scale_wifi_ble);
        findViewById(R.id.wifistatus).setOnClickListener(this);
        findViewById(R.id.sn).setOnClickListener(this);
        findViewById(R.id.scan_wifi).setOnClickListener(this);
        findViewById(R.id.connect_wifi).setOnClickListener(this);
        findViewById(R.id.disconnect).setOnClickListener(this);
        findViewById(R.id.setedname).setOnClickListener(this);
        findViewById(R.id.setedpaw).setOnClickListener(this);
        findViewById(R.id.setedmac).setOnClickListener(this);
        findViewById(R.id.ota).setOnClickListener(this);
        findViewById(R.id.surroundings).setOnClickListener(this);
        findViewById(R.id.check_ip).setOnClickListener(this);
        findViewById(R.id.check_port).setOnClickListener(this);
        findViewById(R.id.check_url).setOnClickListener(this);
        findViewById(R.id.reset).setOnClickListener(this);
        findViewById(R.id.btn_select_file).setOnClickListener(this);

        et_ip = findViewById(R.id.et_ip);
        et_port = findViewById(R.id.et_port);
        et_url = findViewById(R.id.et_url);
        mEditText = findViewById(R.id.select_wifi_et);
        kg = findViewById(R.id.kg);
        jing = findViewById(R.id.jin);
        stlb = findViewById(R.id.st_lb);
        lb = findViewById(R.id.lb);
        kg.setChecked(true);
        mAddress = getIntent().getStringExtra("mac");
        mList = new ArrayList<>();
        ListView listView = findViewById(R.id.log_list);
        listAdapter = new ArrayAdapter<>(this, android.R.layout.simple_list_item_1, mList);
        listView.setAdapter(listAdapter);

        tv_path = findViewById(R.id.tv_path);
        tv_path.setText("file path:" + File.separator + Environment.DIRECTORY_DOCUMENTS + File.separator + FileUtils.FILE_DIR);

        WeakReference weakReference = new WeakReference(new MHandler());
        mMHandler = (MHandler) weakReference.get();
        kg.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance()
                                                                .setWeightUnit(BodyFatDataUtil.KG, BleDeviceConfig.WEIGHT_BODY_FAT_SCALE_WIFI_BLE));
                }
            }
        });
        jing.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance()
                                                                .setWeightUnit(BodyFatDataUtil.JIN, BleDeviceConfig.WEIGHT_BODY_FAT_SCALE_WIFI_BLE));
                }
            }
        });
        stlb.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance()
                                                                .setWeightUnit(BodyFatDataUtil.ST, BleDeviceConfig.WEIGHT_BODY_FAT_SCALE_WIFI_BLE));
                }
            }
        });
        lb.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance()
                                                                .setWeightUnit(BodyFatDataUtil.LB, BleDeviceConfig.WEIGHT_BODY_FAT_SCALE_WIFI_BLE));
                }
            }
        });

        FileUtils.init();
        mDialogList = new ArrayList<>();
        initLauncher();
    }

    private User getDefault() {
        User user = new User();
        user.setModeType(BodyFatDataUtil.MODE_ORDINARY);
        user.setSex(BodyFatDataUtil.SEX_MAN);
        user.setAge(18);
        user.setHeight(170);
        user.setAdc(560);
        user.setWeight(50);
        user.setId(1);
        return user;
    }

    private void initLauncher() {
        launcher = registerForActivityResult(new ResultContact(), result -> {
            if (!TextUtils.isEmpty(result)) {
                SP.getInstance().putOtaFileName(result);
                mList.add(0, getString(R.string.select_document) + result);
                listAdapter.notifyDataSetChanged();
            }
        });
    }

    @Override
    public void onServiceSuccess() {
        BleLog.i(TAG, "服务与界面建立连接成功");
        //与服务建立连接
        if (mBluetoothService != null) {
            mBluetoothService.setOnCallbackBle(this);
            BleDevice bleDevice = mBluetoothService.getBleDevice(mAddress);
            if (bleDevice != null) {
                BodyFatBleUtilsData.init(bleDevice, this, this);
                bodyFatBleUtilsData = BodyFatBleUtilsData.getInstance();
            }
        }
    }


    @Override
    public void onServiceErr() {

    }

    @Override
    public void unbindServices() {
        if (mBluetoothService != null) {
            mBluetoothService.removeOnCallbackBle(this);
        }
    }

    @Override
    public void onStartScan() {

    }

    @Override
    public void onScanning(BleValueBean data) {

    }

    @Override
    public void onScanTimeOut() {

    }

    @Override
    public void onConnecting(String mac) {

    }

    @Override
    public void onDisConnected(String mac, int code) {

    }

    @Override
    public void onServicesDiscovered(String mac) {

    }

    @Override
    public void bleOpen() {

    }

    @Override
    public void bleClose() {

    }

    private String mOldData = "";

    @Override
    public void onWeightData(int status, float weight, int weightUnit, int decimals) {
        String data = "Data Type：" + (status == BodyFatDataUtil.WEIGHT_TESTING ? getString(R.string.real_time) : getString(R.string.stable)) + "\nWeight: " + weight + " \nUnit：" + weightUnit + " \nDecimal point: " + decimals;
        if (mOldData.equals(data)) {
            return;
        }
        mOldData = data;
        mList.add(0, mOldData);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    private int mOldStatus = -1;

    @Override
    public void onStatus(int status) {
        if (mOldStatus == status) {
            return;
        }
        mOldStatus = status;

        switch (status) {
            case BodyFatDataUtil.WEIGHT_TESTING:
                mList.add(0, getString(R.string.measurement_status) + status + "\n" + getString(R.string.real_time_weight));
                break;
            case BodyFatDataUtil.WEIGHT_RESULT:
                mList.add(0, getString(R.string.measurement_status) + status + "\n" + getString(R.string.stable_weight));
                break;
            case BodyFatDataUtil.IMPEDANCE_TESTING:
                mList.add(0, getString(R.string.measurement_status) + status + "\n" + getString(R.string.impedance_test_progress));
                break;
            case BodyFatDataUtil.IMPEDANCE_SUCCESS_DATA:
            case BodyFatDataUtil.IMPEDANCE_SUCCESS:
                mList.add(0, getString(R.string.measurement_status) + status + "\n" + getString(R.string.impedance_test_successful));
                break;
            case BodyFatDataUtil.IMPEDANCE_FAIL:
                mList.add(0, getString(R.string.measurement_status) + status + "\n" + getString(R.string.impedance_test_failed));
                break;
            case BodyFatDataUtil.HEART_TESTING:
                mList.add(0, getString(R.string.measurement_status) + status + "\n" + getString(R.string.heart_rate_measuring));
                break;
            case BodyFatDataUtil.HEART_SUCCESS:
                mList.add(0, getString(R.string.measurement_status) + status + "\n" + getString(R.string.heart_rate_test_successful));
                break;
            case BodyFatDataUtil.HEART_FAIL:
                mList.add(0, getString(R.string.measurement_status) + status + "\n" + getString(R.string.heart_rate_test_failed));
                break;
            case BodyFatDataUtil.TEST_FINISH:
                mList.add(0, getString(R.string.measurement_status) + status + "\n" + getString(R.string.test_completed));
                if (bodyFatBleUtilsData != null) {
                    bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().sendTestStatus(1));
                }
                break;
            case BodyFatDataUtil.MUC_REQUEST_USER_INFO:
                mList.add(0, getString(R.string.measurement_status) + status + "\n" + getString(R.string.request_user_information));
                break;
            default:
                mList.add(0, getString(R.string.measurement_status) + status);

        }
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void onOtaCallback(int status) {
        switch (status) {
            case 0x00:
                mList.add(0, "ota：" + status + " wifiOTA成功");
                break;
            case 0x01:
                mList.add(0, "ota：" + status + " wifiOTA失败");
                break;
            case 0x02:
                mList.add(0, "ota：" + status + " 不支持wifiOTA");
                break;
            case 0x03:
                mList.add(0, "ota：" + status + " 模块主动开始wifiOTA（MCU收到该指令后不能断电，需要等待OTA成功或者失败）");
                break;

        }
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void onAdc(int adc, int algorithmic) {
        mList.add(0, "impedance：" + adc + " 算法位：" + algorithmic);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void onHeartRate(int heartrate) {
        mList.add(0, "HR：" + heartrate);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void onBodyFat(BodyFatRecord bodyFatRecord) {
        mList.add(0, bodyFatRecord.toString());
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void onError(int code) {
        mList.add(0, "ERR：" + code);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void onHistoryMcu(McuHistoryRecordBean mcuHistoryRecordBean) {
        mList.add(0, getString(R.string.history_mcu) + mcuHistoryRecordBean.toString());
        mMHandler.sendEmptyMessage(ToRefreUi);
        //        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void onHistoryApp(AppHistoryRecordBean appHistoryRecordBean) {
        mList.add(0, getString(R.string.history_app) + appHistoryRecordBean.toString());
        mMHandler.sendEmptyMessage(ToRefreUi);

    }

    @Override
    public void onVersion(String version) {
        mList.add(0, "Version：" + version);
        mMHandler.sendEmptyMessage(ToRefreUi);

    }

    @Override
    public void onMcuBatteryStatus(int status, int battery) {
        mList.add(0, "status:" + status + "\n" + getString(R.string.power) + battery + "%");
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void onSysTime(int status, int[] times) {
        mList.add(0, getString(R.string.time_status) + status);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void requestSynTime() {
        mList.add(0, getString(R.string.syn_time));
        bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().synTime());
    }

    @Override
    public void setTimeCallback(int type, int status) {
        String msg = "";
        if (type == CmdConfig.SET_SYS_TIME) {
            msg = getString(R.string.set_current_system_time);
        } else if (type == CmdConfig.SET_DEVICE_TIME) {
            msg = getString(R.string.syn_time);
        }
        if (status == BodyFatDataUtil.STATUS_SUCCESS) {
            msg = msg + status + getString(R.string.success);
        } else if (status == BodyFatDataUtil.STATUS_FAIL) {
            msg = msg + status + getString(R.string.failure);
        } else if (status == BodyFatDataUtil.STATUS_NOT_SUPPORT) {
            msg = msg + status + getString(R.string.not_support);
        }
        mList.add(0, msg);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void requestSynHistoryCallback(int status) {
        if (status == 0) {
            mList.add(0, status + getString(R.string.no_history));
        } else if (status == 1) {
            mList.add(0, status + getString(R.string.start_sending_history));
        } else {
            mList.add(0, status + getString(R.string.end_sending_history));
        }
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void updateUserCallback(int status) {
        if (status == 0) {
            mList.add(0, status + getString(R.string.update_user_list_success));
        } else if (status == 1) {
            mList.add(0, status + getString(R.string.update_user_success));
        } else if (status == 2) {
            mList.add(0, status + getString(R.string.update_user_list_failed));
        } else {
            mList.add(0, status + getString(R.string.update_user_failed));
        }
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void setUnitCallback(int status) {
        if (status == 0) {
            mList.add(0, getString(R.string.issued_unit_callback) + status + getString(R.string.success));
        } else if (status == 1) {
            mList.add(0, getString(R.string.issued_unit_callback)  + status + getString(R.string.failure));
        } else {
            mList.add(0, getString(R.string.issued_unit_callback)  + status + getString(R.string.not_support));
        }
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void requestUserData(int status) {
        if (status == 0x01) {
            mList.add(0, getString(R.string.send_user_info) + status);
        } else if (status == 0x03) {
            mList.add(0, getString(R.string.send_user_info_success) + status);
        } else {
            mList.add(0, getString(R.string.send_user_info_failure) + status);
        }
        mMHandler.sendEmptyMessage(ToRefreUi);
    }


    @Override
    public void OnBleAndWifiStatus(int blestatus, int wifistatus, int workstatus) {
        mList.add(0, getString(R.string.ble_status) + blestatus +"\n"+
                getString(R.string.wifi_status) + wifistatus +"\n"+
                getString(R.string.work_status) + workstatus);
        mMHandler.sendEmptyMessage(ToRefreUi);

    }

    @Override
    public void OnWifiScanStatus(int Status) {
        mList.add(0, getString(R.string.scan_wifi_status) + Status);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    private HashMap<Integer, String> mHashMap = new HashMap();

    @Override
    public void OnWifiListName(int no, String name) {

        //        mList.add(0,"WIFI序号: "+no+" WIFI名称: "+name);
        mHashMap.put(no, name);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    private HashMap<Integer, String> wifimacMap = new HashMap();

    @Override
    public void OnWifiListInfo(int no, String mac, int db, int type, int wifistatus) {

        wifimacMap.put(no, mac);
        mList.add(0, "WIFI no: " + no + " WIFI name：" + mHashMap.get(no) + " WIFI mac: " + mac + " db: " + db + " type: " + type + " wifistata" + wifistatus);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void OnWifiCurrentConnect(String name) {
        mList.add(0, getString(R.string.current_connected_wifi_name) + name);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void OnWifiScanFinish(int wifiNum) {
        mList.add(0, getString(R.string.scan_wifi_number) + wifiNum);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    private boolean issetMac = false;

    /**
     * @param type
     * @param status {@link BodyFatDataUtil#STATUS_SUCCESS}
     */
    @Override
    public void OnSetWifiNameOrPwdOrConnectCallback(int type, int status) {
        if (type == CmdConfig.SET_WIFI_MAC) {
            mList.add(0, getString(R.string.get_set_mac_address_status) + status);
            if (status == BodyFatDataUtil.STATUS_SUCCESS) {
                issetMac = true;
            }

        }
        if (type == CmdConfig.SET_WIFI_PAW) {
            mList.add(0, getString(R.string.get_set_password_status) + status);
            if (status == BodyFatDataUtil.STATUS_SUCCESS && issetMac) {
                mMHandler.sendEmptyMessage(ConnectWifi);
            }
        }
        if (type == CmdConfig.DIS_OR_CON_WIFI) {
            mList.add(0, getString(R.string.initiate_connection)+":" + status);
            mMHandler.sendEmptyMessage(ToRefreUi);
        }

    }

    @Override
    public void getSelectWifiMac(String mac) {
        mList.add(0, getString(R.string.get_set_wifi_mac_address) + mac);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void getSelectWifiPaw(String paw) {
        mList.add(0, getString(R.string.get_set_wifi_password) + paw);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }


    @Override
    public void getDid(long sn) {
        mList.add(0, "sn: " + sn);
        mMHandler.sendEmptyMessage(ToRefreUi);
    }

    @Override
    public void onSetIpStatus(int status) {
        if (status == 0) {
            mList.add(0, getString(R.string.set_environment_ip_success));
            int port = Integer.parseInt(et_port.getText().toString());
            mList.add(0, getString(R.string.set_environment_port) + port);
            setPort(port);
        } else {
            mList.add(0, getString(R.string.set_environment_ip_failure));
        }
        listAdapter.notifyDataSetChanged();
    }

    @Override
    public void onSetPortStatus(int status) {
        if (status == 0) {
            mList.add(0, getString(R.string.set_environment_port_success));
            String ipUrlStr = et_url.getText().toString();
            mList.add(0, getString(R.string.set_environment_url) + ipUrlStr);
            setIpUrl(convertToASCII(ipUrlStr));
        } else {
            mList.add(0, getString(R.string.set_environment_port_failure));
        }
        listAdapter.notifyDataSetChanged();
    }

    @Override
    public void onSetIpUrlStatus(int status) {
        if (status == 0) {
            mList.add(0, getString(R.string.set_environment_url_success));
        } else {
            mList.add(0, getString(R.string.set_environment_url_failure));
        }
        listAdapter.notifyDataSetChanged();
    }

    @Override
    public void onIpData(String ip) {
        mList.add(0, "ip：" + ip);
        listAdapter.notifyDataSetChanged();
    }

    @Override
    public void onPortData(int port) {
        mList.add(0, "port：" + port);
        listAdapter.notifyDataSetChanged();
    }

    @Override
    public void onUrlData(String url) {
        mList.add(0, "url：" + url);
        listAdapter.notifyDataSetChanged();
    }

    @Override
    public void onClick(View v) {
        int id = v.getId();
        switch (id) {
            case R.id.reset:
                mList.add(0, getString(R.string.reset));
                listAdapter.notifyDataSetChanged();
                bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().reset());
                break;
            case R.id.wifistatus:
                bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().queryBleStatus());
                break;
            case R.id.sn:
                bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().getSnDeviceDid());
                break;
            case R.id.scan_wifi:
                bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().scanWifi());
                break;
            case R.id.connect_wifi:
                try {
                    int selectWifi = Integer.valueOf(mEditText.getText().toString().trim());
                    if (mHashMap.get(selectWifi) != null && wifimacMap.get(selectWifi) != null) {
                        WifiDialog.newInstance()
                                  .setTitle(mHashMap.get(selectWifi), wifimacMap.get(selectWifi))
                                  .setOnDialogListener(new WifiDialog.OnDialogListener() {
                                      @Override
                                      public void tvCancelListener(View v) {

                                      }

                                      @Override
                                      public void tvSucceedListener(View v, String data) {
                                          bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance()
                                                                                      .setWifiMac(wifimacMap.get(selectWifi)));
                                          if (data.equals("") || data.length() >= 8) {
                                              setPaw(data);
                                          } else {
                                              Toast.makeText(WeightScaleWifiBleActivity.this, R.string.password_format_err, Toast.LENGTH_SHORT)
                                                   .show();
                                          }
                                      }

                                      @Override
                                      public void etModifyName(EditText v) {

                                      }
                                  })
                                  .show(getSupportFragmentManager());
                    }
                } catch (NumberFormatException e) {
                    e.printStackTrace();
                    mMHandler.sendEmptyMessage(ConnectWifi);
                }

                break;
            case R.id.setedmac:
                bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().getSelectWifiMac());
                break;
            case R.id.setedpaw:
                bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().getConnectWifiPwd());
                break;
            case R.id.setedname:
                bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().getConnectWifiName());
                break;
            case R.id.disconnect:
                bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().disconnectWifi());
                break;
            case R.id.ota:
//                bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().ota());
//                OtaUtil otaUtil=new OtaUtil(this,mBluetoothService.getBleDevice(mAddress));
                showFileChooser();
                break;
            case R.id.surroundings:

                String ipStr = et_ip.getText().toString();
                setIp(convertToASCII(ipStr));
                mList.add(0, getString(R.string.set_environment_ip) + ipStr);
                listAdapter.notifyDataSetChanged();
                break;
            case R.id.check_ip:
                mList.add(0, getString(R.string.view_environment_ip));
                listAdapter.notifyDataSetChanged();
                bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().checkIp());
                break;
            case R.id.check_port:
                mList.add(0, getString(R.string.view_environment_port));
                listAdapter.notifyDataSetChanged();
                bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().checkPort());
                break;
            case R.id.check_url:
                mList.add(0, getString(R.string.view_environment_url));
                listAdapter.notifyDataSetChanged();
                bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().checkUrl());
                break;

            case R.id.btn_select_file:
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
                    launcher.launch(true);
                } else {
                    mDialogList.clear();
                    ArrayList<String> list = FileUtils.list();
                    for (String s : list) {
                        mDialogList.add(new DialogStringImageBean(s, 0));
                    }
                    ShowListDialogFragment.newInstance()
                                          .setTitle("")
                                          .setCancel("", 0)
                                          .setCancelBlank(true)
                                          .setBackground(true)
                                          .setBottom(false)
                                          .setList(mDialogList)
                                          .setOnDialogListener(new ShowListDialogFragment.onDialogListener() {
                                              @Override
                                              public void onItemListener(int position) {
                                                  if (mDialogList.size() > position) {
                                                      DialogStringImageBean dialogStringImageBean = mDialogList.get(position);
                                                      String name = dialogStringImageBean.getName();
                                                      SP.getInstance().putOtaFileName(name);
                                                  }
                                              }
                                          })
                                          .show(getSupportFragmentManager());
                }
                break;

        }

    }


    private byte[] convertToASCII(String string) {
        char[] ch = string.toCharArray();
        byte[] tmp = new byte[ch.length];
        for (int i = 0; i < ch.length; i++) {
            tmp[i] = (byte) Integer.valueOf(ch[i]).intValue();
        }
        return tmp;
    }


    private void setIp(byte[] ips) {
        if (ips.length <= 14)
            bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().environmentIp(0, ips));
        else {
            boolean isend = false;
            int i = 0;
            byte[] byte1 = ips;
            while (!isend) {
                if (byte1.length > 14) {
                    byte[] bytes = new byte[14];
                    System.arraycopy(ips, i, bytes, 0, bytes.length);
                    bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance()
                                                                .environmentIp(1, bytes));
                    i = i + 14;
                    byte1 = Arrays.copyOf(ips, ips.length - i);
                } else {
                    isend = true;
                    byte[] bytes = new byte[ips.length - i];
                    System.arraycopy(ips, i, bytes, 0, bytes.length);
                    bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance()
                                                                .environmentIp(0, bytes));
                }

            }
        }

    }

    private void setPort(int port) {
        bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().environmentPort(port));
    }

    private void setIpUrl(byte[] setIpUrl) {
        if (setIpUrl.length <= 14)
            bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().environmentUrl(0, setIpUrl));
        else {
            boolean isend = false;
            int i = 0;
            byte[] byte1 = setIpUrl;
            while (!isend) {
                if (byte1.length > 14) {
                    byte[] bytes = new byte[14];
                    System.arraycopy(setIpUrl, i, bytes, 0, bytes.length);
                    bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance()
                                                                .environmentUrl(1, bytes));
                    i = i + 14;
                    byte1 = Arrays.copyOf(setIpUrl, setIpUrl.length - i);
                } else {
                    isend = true;
                    byte[] bytes = new byte[setIpUrl.length - i];
                    System.arraycopy(setIpUrl, i, bytes, 0, bytes.length);
                    bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance()
                                                                .environmentUrl(0, bytes));
                }

            }
        }

    }

    private final int ToRefreUi = 300;
    private final int ConnectWifi = 400;

    private class MHandler extends Handler {
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            switch (msg.what) {
                case ToRefreUi:
                    if (listAdapter != null) {
                        listAdapter.notifyDataSetChanged();
                    }
                    break;
                case ConnectWifi:
                    bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().connectWifi());
                    break;
            }
        }
    }


    /**
     * wifi密码一次只能传14个byte
     * 如果密码长度超过14个byte 就需要分包传送
     * subpackage 为0 时，表示后面还有数据
     * subpackage 为1 时，表示数据小于或等于14个byte,后面没有数据
     *
     * @param paw
     */
    private void setPaw(String paw) {
        if (paw.isEmpty()) {
            byte[] bytes = new byte[0];
            bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance().setWifiPwd(0, bytes));
        } else {
            byte[] password = BleStrUtils.stringToBytes(paw);
            if (password != null) {
                if (password.length < 14)
                    bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance()
                                                                .setWifiPwd(0, password));
                else {
                    boolean isend = false;
                    int i = 0;
                    byte[] byte1 = password;
                    while (!isend) {
                        if (byte1.length > 14) {
                            byte[] bytes = new byte[14];
                            System.arraycopy(password, i, bytes, 0, bytes.length);

                            bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance()
                                                                        .setWifiPwd(1, bytes));
                            i = i + 14;
                            byte1 = Arrays.copyOf(password, password.length - i);
                        } else {
                            isend = true;
                            byte[] bytes = new byte[password.length - i];
                            System.arraycopy(password, i, bytes, 0, bytes.length);

                            bodyFatBleUtilsData.sendData(BodyFatDataUtil.getInstance()
                                                                        .setWifiPwd(0, bytes));
                        }

                    }


                }
            }
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode == RESULT_OK) {
            Uri uri = data.getData();
            String path = uri.getPath();
            SP.getInstance().put("WIFI_BLE_OTA_FILE_PATH", path);
            mList.add(0, "select file:" + path);
            listAdapter.notifyDataSetChanged();
        } else {

        }
    }

    private static final int FILE_SELECT_CODE = 0x1002;

    private void showFileChooser() {
        Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
        intent.setType("*/*");
        intent.addCategory(Intent.CATEGORY_OPENABLE);

        try {
            startActivityForResult(Intent.createChooser(intent, "Select a File to Upload"), FILE_SELECT_CODE);
        } catch (android.content.ActivityNotFoundException ex) {
            Toast.makeText(this, "Please install a File Manager.", Toast.LENGTH_SHORT).show();
        }
    }

}